// This file is generated by 'gendbfiles' - DO NOT EDIT

package models

// This file contains constants for all db names involved in a mapped struct
// It also add some accessors on the struct types so they implement a 'Mapped' interface

// Mapped is the common interface of all structs that are mapped in the database
type Mapped interface {
	Table() string
	PKeyColumn() string
	Columns(withPKey bool) []string
	Values(columns ...string) []interface{}
}

const (
	// table and column names

	// AccountDBTable is the name of the table where AccountDB are stored
	AccountDBTable = "account"

	// AccountDBPKeyColumn is the name of the primary key
	AccountDBPKeyColumn = AccountDBNameColumn

	// AccountDBNameColumn is the name of the column containing field "Name" data
	AccountDBNameColumn = "name"

	// AccountDBIsUserColumn is the name of the column containing field "IsUser" data
	AccountDBIsUserColumn = "is_user"

	// ApikeyDescriptionColumn is the name of the column containing field "Description" data
	ApikeyDescriptionColumn = "description"

	// ApikeyNameColumn is the name of the column containing field "Name" data
	ApikeyNameColumn = "name"

	// ApikeyValueColumn is the name of the column containing field "Value" data
	ApikeyValueColumn = "value"

	// ApikeyDBTable is the name of the table where ApikeyDB are stored
	ApikeyDBTable = "users_apikey"

	// ApikeyDBPKeyColumn is the name of the primary key
	ApikeyDBPKeyColumn = ApikeyDBIDColumn

	// ApikeyDBDescriptionColumn is the name of the column containing field "Description" data
	ApikeyDBDescriptionColumn = "description"

	// ApikeyDBNameColumn is the name of the column containing field "Name" data
	ApikeyDBNameColumn = "name"

	// ApikeyDBValueColumn is the name of the column containing field "Value" data
	ApikeyDBValueColumn = "value"

	// ApikeyDBIDColumn is the name of the column containing field "ID" data
	ApikeyDBIDColumn = "id"

	// ApikeyDBUsernameColumn is the name of the column containing field "Username" data
	ApikeyDBUsernameColumn = "username"

	// TemplateAccountColumn is the name of the column containing field "Account" data
	TemplateAccountColumn = "account"

	// TemplateDataSchemaColumn is the name of the column containing field "DataSchema" data
	TemplateDataSchemaColumn = "data_schema"

	// TemplateDescriptionColumn is the name of the column containing field "Description" data
	TemplateDescriptionColumn = "description"

	// TemplateLanguageColumn is the name of the column containing field "Language" data
	TemplateLanguageColumn = "language"

	// TemplateLocaleColumn is the name of the column containing field "Locale" data
	TemplateLocaleColumn = "locale"

	// TemplateMetadataColumn is the name of the column containing field "Metadata" data
	TemplateMetadataColumn = "metadata"

	// TemplateNameColumn is the name of the column containing field "Name" data
	TemplateNameColumn = "name"

	// TemplateProducesColumn is the name of the column containing field "Produces" data
	TemplateProducesColumn = "produces"

	// TemplateStaticMetadataColumn is the name of the column containing field "StaticMetadata" data
	TemplateStaticMetadataColumn = "static_metadata"

	// TemplateTitleColumn is the name of the column containing field "Title" data
	TemplateTitleColumn = "title"

	// TemplateVersionColumn is the name of the column containing field "Version" data
	TemplateVersionColumn = "version"

	// TemplateDBTable is the name of the table where TemplateDB are stored
	TemplateDBTable = "template"

	// TemplateDBPKeyColumn is the name of the primary key
	TemplateDBPKeyColumn = TemplateDBIDColumn

	// TemplateDBAccountColumn is the name of the column containing field "Account" data
	TemplateDBAccountColumn = "account"

	// TemplateDBDataSchemaColumn is the name of the column containing field "DataSchema" data
	TemplateDBDataSchemaColumn = "data_schema"

	// TemplateDBDescriptionColumn is the name of the column containing field "Description" data
	TemplateDBDescriptionColumn = "description"

	// TemplateDBLanguageColumn is the name of the column containing field "Language" data
	TemplateDBLanguageColumn = "language"

	// TemplateDBLocaleColumn is the name of the column containing field "Locale" data
	TemplateDBLocaleColumn = "locale"

	// TemplateDBMetadataColumn is the name of the column containing field "Metadata" data
	TemplateDBMetadataColumn = "metadata"

	// TemplateDBNameColumn is the name of the column containing field "Name" data
	TemplateDBNameColumn = "name"

	// TemplateDBProducesColumn is the name of the column containing field "Produces" data
	TemplateDBProducesColumn = "produces"

	// TemplateDBStaticMetadataColumn is the name of the column containing field "StaticMetadata" data
	TemplateDBStaticMetadataColumn = "static_metadata"

	// TemplateDBTitleColumn is the name of the column containing field "Title" data
	TemplateDBTitleColumn = "title"

	// TemplateDBVersionColumn is the name of the column containing field "Version" data
	TemplateDBVersionColumn = "version"

	// TemplateDBIDColumn is the name of the column containing field "ID" data
	TemplateDBIDColumn = "id"

	// TemplateDBInternalVersionColumn is the name of the column containing field "InternalVersion" data
	TemplateDBInternalVersionColumn = "internal_version"

	// TemplateDBBytesBodyColumn is the name of the column containing field "BytesBody" data
	TemplateDBBytesBodyColumn = "body"

	// UserDBTable is the name of the table where UserDB are stored
	UserDBTable = "users"

	// UserDBPKeyColumn is the name of the primary key
	UserDBPKeyColumn = UserDBUsernameColumn

	// UserDBIsAdminColumn is the name of the column containing field "IsAdmin" data
	UserDBIsAdminColumn = "is_admin"

	// UserDBUsernameColumn is the name of the column containing field "Username" data
	UserDBUsernameColumn = "username"

	// UserDBPasswordColumn is the name of the column containing field "Password" data
	UserDBPasswordColumn = "password"

	// UserinfoIsAdminColumn is the name of the column containing field "IsAdmin" data
	UserinfoIsAdminColumn = "is_admin"

	// UserinfoUsernameColumn is the name of the column containing field "Username" data
	UserinfoUsernameColumn = "username"
)

var (
	// DBAllTables is the list of all the database table names
	DBAllTables = []string{
		AccountDBTable,
		ApikeyDBTable,
		TemplateDBTable,
		UserDBTable,
	}
	// AccountDBDataColumns is the list of the columns for the AccountDB structure, expect its primary key
	AccountDBDataColumns = []string{
		AccountDBIsUserColumn,
	}

	// AccountDBColumns is the list of the columns for the AccountDB structure
	AccountDBColumns = append(
		[]string{ AccountDBNameColumn },
		AccountDBDataColumns...,
	)
	// ApikeyColumns is the list of the columns for the Apikey structure
	ApikeyColumns = []string{
		ApikeyDescriptionColumn,
		ApikeyNameColumn,
		ApikeyValueColumn,
	}
	// ApikeyDBDataColumns is the list of the columns for the ApikeyDB structure, expect its primary key
	ApikeyDBDataColumns = []string{
		ApikeyDBDescriptionColumn,
		ApikeyDBNameColumn,
		ApikeyDBValueColumn,
		ApikeyDBUsernameColumn,
	}

	// ApikeyDBColumns is the list of the columns for the ApikeyDB structure
	ApikeyDBColumns = append(
		[]string{ ApikeyDBIDColumn },
		ApikeyDBDataColumns...,
	)
	// TemplateColumns is the list of the columns for the Template structure
	TemplateColumns = []string{
		TemplateAccountColumn,
		TemplateDataSchemaColumn,
		TemplateDescriptionColumn,
		TemplateLanguageColumn,
		TemplateLocaleColumn,
		TemplateMetadataColumn,
		TemplateNameColumn,
		TemplateProducesColumn,
		TemplateStaticMetadataColumn,
		TemplateTitleColumn,
		TemplateVersionColumn,
	}
	// TemplateDBDataColumns is the list of the columns for the TemplateDB structure, expect its primary key
	TemplateDBDataColumns = []string{
		TemplateDBAccountColumn,
		TemplateDBDataSchemaColumn,
		TemplateDBDescriptionColumn,
		TemplateDBLanguageColumn,
		TemplateDBLocaleColumn,
		TemplateDBMetadataColumn,
		TemplateDBNameColumn,
		TemplateDBProducesColumn,
		TemplateDBStaticMetadataColumn,
		TemplateDBTitleColumn,
		TemplateDBVersionColumn,
		TemplateDBInternalVersionColumn,
		TemplateDBBytesBodyColumn,
	}

	// TemplateDBColumns is the list of the columns for the TemplateDB structure
	TemplateDBColumns = append(
		[]string{ TemplateDBIDColumn },
		TemplateDBDataColumns...,
	)
	// UserDBDataColumns is the list of the columns for the UserDB structure, expect its primary key
	UserDBDataColumns = []string{
		UserDBIsAdminColumn,
		UserDBPasswordColumn,
	}

	// UserDBColumns is the list of the columns for the UserDB structure
	UserDBColumns = append(
		[]string{ UserDBUsernameColumn },
		UserDBDataColumns...,
	)
	// UserinfoColumns is the list of the columns for the Userinfo structure
	UserinfoColumns = []string{
		UserinfoIsAdminColumn,
		UserinfoUsernameColumn,
	}
)

// Table returns the database table name
func (s AccountDB) Table() string {
	return AccountDBTable
}

// PKeyColumn returns the database table primary key column name
func (s AccountDB) PKeyColumn() string {
	return AccountDBPKeyColumn
}

// Columns returns the database table column names
func (s AccountDB) Columns(withPKey bool) []string {
	if withPKey {
		return AccountDBColumns
	}
	return AccountDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s AccountDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "name":
			values[i] = s.Name
		case "is_user":
			values[i] = s.IsUser
		}
	}
	return values
}

// Columns returns the database table column names
func (s Apikey) Columns() []string {
	return ApikeyColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Apikey) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "description":
			values[i] = s.Description
		case "name":
			values[i] = s.Name
		case "value":
			values[i] = s.Value
		}
	}
	return values
}

// Table returns the database table name
func (s ApikeyDB) Table() string {
	return ApikeyDBTable
}

// PKeyColumn returns the database table primary key column name
func (s ApikeyDB) PKeyColumn() string {
	return ApikeyDBPKeyColumn
}

// Columns returns the database table column names
func (s ApikeyDB) Columns(withPKey bool) []string {
	if withPKey {
		return ApikeyDBColumns
	}
	return ApikeyDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s ApikeyDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "description":
			values[i] = s.Description
		case "name":
			values[i] = s.Name
		case "value":
			values[i] = s.Value
		case "id":
			values[i] = s.ID
		case "username":
			values[i] = s.Username
		}
	}
	return values
}

// Columns returns the database table column names
func (s Template) Columns() []string {
	return TemplateColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Template) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "account":
			values[i] = s.Account
		case "data_schema":
			values[i] = s.DataSchema
		case "description":
			values[i] = s.Description
		case "language":
			values[i] = s.Language
		case "locale":
			values[i] = s.Locale
		case "metadata":
			values[i] = s.Metadata
		case "name":
			values[i] = s.Name
		case "produces":
			values[i] = s.Produces
		case "static_metadata":
			values[i] = s.StaticMetadata
		case "title":
			values[i] = s.Title
		case "version":
			values[i] = s.Version
		}
	}
	return values
}

// Table returns the database table name
func (s TemplateDB) Table() string {
	return TemplateDBTable
}

// PKeyColumn returns the database table primary key column name
func (s TemplateDB) PKeyColumn() string {
	return TemplateDBPKeyColumn
}

// Columns returns the database table column names
func (s TemplateDB) Columns(withPKey bool) []string {
	if withPKey {
		return TemplateDBColumns
	}
	return TemplateDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s TemplateDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "account":
			values[i] = s.Account
		case "data_schema":
			values[i] = s.DataSchema
		case "description":
			values[i] = s.Description
		case "language":
			values[i] = s.Language
		case "locale":
			values[i] = s.Locale
		case "metadata":
			values[i] = s.Metadata
		case "name":
			values[i] = s.Name
		case "produces":
			values[i] = s.Produces
		case "static_metadata":
			values[i] = s.StaticMetadata
		case "title":
			values[i] = s.Title
		case "version":
			values[i] = s.Version
		case "id":
			values[i] = s.ID
		case "internal_version":
			values[i] = s.InternalVersion
		case "body":
			values[i] = s.BytesBody
		}
	}
	return values
}

// Table returns the database table name
func (s UserDB) Table() string {
	return UserDBTable
}

// PKeyColumn returns the database table primary key column name
func (s UserDB) PKeyColumn() string {
	return UserDBPKeyColumn
}

// Columns returns the database table column names
func (s UserDB) Columns(withPKey bool) []string {
	if withPKey {
		return UserDBColumns
	}
	return UserDBDataColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s UserDB) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "is_admin":
			values[i] = s.IsAdmin
		case "username":
			values[i] = s.Username
		case "password":
			values[i] = s.Password
		}
	}
	return values
}

// Columns returns the database table column names
func (s Userinfo) Columns() []string {
	return UserinfoColumns
}

// Values returns the values for a list of columns. If a column does not exits,
// the corresponding value is left empty
func (s Userinfo) Values(columns ...string) []interface{} {
	values := make([]interface{}, len(columns))
	for i, column := range columns {
		switch column {
		case "is_admin":
			values[i] = s.IsAdmin
		case "username":
			values[i] = s.Username
		}
	}
	return values
}
